<?php
namespace Modules\Cadastros\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Controller\Crud;


class CentraldeComprasController extends \Teknisa\GER\Controllers\TeknisaCrud 
{

    protected $dataSourceName = "cmp01500_central_de_compras";
	private $supUtilities;
	
	
	public function __construct($crudService, ParameterBag $parameterBag, $connection, $supUtilities) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->connection = $connection;
        $this->supUtilities = $supUtilities;
    }

	public function removeDependencia(DTO\Request $request, DTO\Response $response) {
	    
	    $rowObj = $request->getRow();
    	$rowArray = (array) $rowObj;
        $codUnidade = $this->supUtilities->insertLista($rowArray);
        $row['CDFILIAL'] = "_NRLISTA=".$codUnidade ;
        
        $param = array(
            'P_CDFILIAL' => $row['CDFILIAL']
        );
        
    	$query = 'UPDATE FILIAL SET CDFILCENTCMP = NULL WHERE (VALOR_NA_LISTA(FILIAL.CDFILIAL, :P_CDFILIAL) <> 0)';
		try {
		    $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $this->supUtilities->deleteLista($codUnidade);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
	}
	
    public function salvaDependencia(DTO\Request $request, DTO\Response $response) {
    
        try{
		    $data = $request->getDataSet()->getRows();
		    $codUnidade = $this->supUtilities->insertLista($data[0]['CDFILIALCENT']);
            $data[0]['CDFILIALCENT'] = "_NRLISTA=".$codUnidade ;
		    
	        if($data[0]['CDFILIAL'] == $data[0]['CDFILCENTCMP']){
    	        throw new \Exception('Filial informada deve ser diferente da central de compras');    
	        }
	       // print_r($data[0]).die();
            $this->connection->beginTransaction();
            $query = 'UPDATE FILIAL 
                      SET     
                        CDFILCENTCMP = :P_CDFILCENTCMP 
                      WHERE     
                        (VALOR_NA_LISTA(FILIAL.CDFILIAL, :L_CDFILIAL) <> 0)';
            $stmt = $this->connection->prepare($query);
            
            $stmt->execute(array(
                "P_CDFILCENTCMP" => $data[0]['CDFILCENTCMP'],
                "L_CDFILIAL" => $data[0]['CDFILIALCENT']

                
            ));
            $this->supUtilities->deleteLista($codUnidade);
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
	}
}